
/*
 *  HP 9000 Series 800 Linker, Copyright Hewlett-Packard Co. 1985-1999  
 *  prod_version.h	Define the product version part of the what string.
 *
 *			This file is included by all the linker related
 *			products.  Defines PRODUCT_VERSION, a string.
 *			Also defines BUILD_STAMP which is typically defined
 *			in the makefile which does the compile.
 *
 */

#ifndef BUILD_STAMP
#define BUILD_STAMP		"EXPERIMENTAL"
#endif

#ifndef HANDLE_EM_ARCH_ONLY /* PA Information */

#define PROJECT_INFO       "92453-07 linker command s800.sgs"

#define PRODUCT_VERSION    "B.11.14" /* Site-specific chatr64, strip64, elfdump for I2 */


#ifdef HANDLE_PA_ARCH_ONLY  /* PA64 */
	#define PRODUCT_TYPE	"PA64 "
#endif

#if 0 /* for archival purposes only */
        #define PRODUCT_VERSION    "B.11.13" /* 11.00 ACE IC6 */
        #define PRODUCT_VERSION    "B.11.12" /* 11.X BE  (990830) */
        #define PRODUCT_VERSION    "B.11.11" /* 11.00 ACE (9911 EP) patch */ 
        #define PRODUCT_VERSION    "B.11.10" /* ar64 site-specific patch */ 
/* used for PA64 before */
	#define PRODUCT_VERSION	   "PA64 B.11.08" /* Post-Dart43 (Mondo) */
	#define PRODUCT_VERSION	   "PA64 B.11.06" /* 11.01/Dart43 IB4 GS */
	#define PRODUCT_VERSION	   "PA64 B.11.05" /* 11.01/Dart43 IB3 GS */
	#define PRODUCT_VERSION	   "PA64 B.11.04" /* 11.01/Dart43 IB2 GS */
	#define PRODUCT_VERSION	   "PA64 B.11.03" /* 11.01/Dart43 IB1 GS */
	/* skipped B.11.02 to make the version number same as 32-bit LINKER */
	#define PRODUCT_VERSION	   "PA64 B.11.01" /* 08/18/98 PHSS_16181 */
	#define PRODUCT_VERSION	   "PA64 B.11.00" /* 08/26/97 IC19 GS */
	#define PRODUCT_VERSION	   "PA64.00.25" /* 07/14/97 IC17 GS */
	#define PRODUCT_VERSION    "PA64.00.20" /* 10/23/96 BE2 */
	#define PRODUCT_VERSION    "PA64.00.08" /* 10/10/96 BE1 patch */
	#define PRODUCT_VERSION    "PA64.00.07" /* 9/3/96 BE1 patch */
	#define PRODUCT_VERSION    "PA64.00.06" /* 7/29/96 BE1 patch */
	#define PRODUCT_VERSION    "PA64.00.05" /* 7/3/96 BE1 patch */
	#define PRODUCT_VERSION    "PA64.00.04" /* 6/7/96 BE1 patch */
	#define PRODUCT_VERSION    "PA64.00.03" /* 5/1/96 BE1 patch */
	#define PRODUCT_VERSION    "PA64.00.02" /* 3/26/96 BE1 patch (BE1.1) */
	#define PRODUCT_VERSION    "PA64.00.01" /* 2/22/96 BE1 */

/* used for PA32 before */
	#define PRODUCT_VERSION    "B.11.09" /* 11.X BE (990625) */ 
	#define PRODUCT_VERSION    "B.11.08" /* Post-Dart43 (Mondo) PHSS_18072 */ 
	#define PRODUCT_VERSION    "B.11.07" /* ar32 handles long symbol name */
	#define PRODUCT_VERSION    "B.11.06" /* 11.01/Dart43 IB4 GS */
	#define PRODUCT_VERSION    "B.11.05" /* 11.01/Dart43 IB3 GS */
	#define PRODUCT_VERSION    "B.11.04" /* 11.01/Dart43 IB2 GS */
	#define PRODUCT_VERSION    "B.11.03" /* 11.01/Dart43 IB1 GS */
	#define PRODUCT_VERSION    "B.11.02" /* 11.Post-Rocklin DOOM linker for I2 */
	#define PRODUCT_VERSION    "B.11.01" /* 11.Post-Rocklin GS */ 
       	                              /* Rocklin went out with 11.00 */
	#define PRODUCT_VERSION    "B.11.00" /* 11.Roseville IC19 GS */ 
	#define PRODUCT_VERSION    "B.10.60" /* 10.Sacramento official */ 
	#define PRODUCT_VERSION    "X.10.22" /* 10.Sacramento IC15 Patch C GS */ 
	#define PRODUCT_VERSION    "X.10.21" /* 10.Sacramento IC1? GS */ 
	#define PRODUCT_VERSION    "X.10.18.01" /* 10.Sacramento IC15 GS SWAT fix */ 
	#define PRODUCT_VERSION    "X.10.19" /* 10.Sacramento BLD18 GS */ 
	#define PRODUCT_VERSION    "X.10.18" /* 10.Sacramento BLD17 IC15 GS */ 
	#define PRODUCT_VERSION    "X.10.17" /* 10.Sacramento BLD16 IC14 GS */ 
	#define PRODUCT_VERSION    "X.10.16" /* 10.Sacramento BLD16 IC14 BE/GS */ 
	#define PRODUCT_VERSION    "X.10.15" /* 10.Sacramento BLD15 IC13 BE/GS */ 
	#define PRODUCT_VERSION    "X.10.14" /* 10.Sacramento IC12 BE/GS */ 
	#define PRODUCT_VERSION    "X.10.13" /* 10.Sacramento IC11 GS */ 

	#define PRODUCT_VERSION    "X.10.12" /* 10.Sacramento IC12 BE */ 
	#define PRODUCT_VERSION    "X.10.11" /* 10.Sacramento IC11 BE */ 
	#define PRODUCT_VERSION    "X.10.09" /* 10.Sacramento IC10 GS */ 
	#define PRODUCT_VERSION    "X.10.08" /* 10.Sacramento IC9 GS */ 
	#define PRODUCT_VERSION    "X.10.07" /* 10.Sacramento IC8 GS and IC9 */ 
	#define PRODUCT_VERSION    "X.10.06" /* 10.Sacramento IC8 BE */ 
	#define PRODUCT_VERSION    "X.10.05" /* 10.Sacramento IC8 BE used in IC7 too */ 

	#define PRODUCT_VERSION    "C.10.04" /* 10.Sacramento IC7 GS */ 
	#define PRODUCT_VERSION    "C.10.03" /* 10.Sacramento IC7 BE IC6 GS     */ 
				    	 /* TSD_IC2 label                   */

	#define PRODUCT_VERSION    "C.10.02" /* 10.Sacramento BE  4/17/96       */
				     /* LINKER_UX10.SACTO.BE_960410.143000 */
	#define PRODUCT_VERSION    "C.10.01" /* 10.Sacramento IC6 		*/
				     /* LINKER_UX10.SACTO_960410.143000 */
	#define PRODUCT_VERSION    "C.10.00" /* Initial 10.Sacramento sequence */
	#define PRODUCT_VERSION    "B.10.04" /*              */
			             /* B.10.03 was also used for the 
				     ** 10.DV early access release.
				     */
	#define PRODUCT_VERSION    "B.10.03" /* 10.DV GS IC8 */
	#define PRODUCT_VERSION    "B.10.02" /* Start new sequence for Davis */
	#define PRODUCT_VERSION    "A.10.41" /* 10.10 (Walnut Creek) Cycle L */
	#define PRODUCT_VERSION    "A.10.40" /* Force a skip of A.10.39, since that
					was used for a patch for 10.MLP branch.
					The MLP branch will continue to use
					A.10.39.XX, and top of trunk will use
					A.10.40 and onward. */
	#define PRODUCT_VERSION    "A.10.38" /* 10.MLP core, Milpitas release, */
                                     /* label: LINKER_UX_10.MLP_BL03   */
	#define PRODUCT_VERSION    "A.09.37" 
	#define PRODUCT_VERSION    "A.10.36" /* 10.0 Cycle IC3 LINKER_UX_10.0_IC3_00 */
	#define PRODUCT_VERSION    "A.10.35"    /* 10.0 Cycle IC3                */
	#define PRODUCT_VERSION    "A.10.34"    /* 10.0 Cycle CC BE/GS           */
	#define PRODUCT_VERSION    "A.10.33"    /* 10.0 Cycle BB BE/GS           */
	#define PRODUCT_VERSION    "A.10.32"    /* 10.0 Cycle Z BE/GS           */
	#define PRODUCT_VERSION    "A.10.31"    /* 10.0 Cycle X BE/GS           */
	#define PRODUCT_VERSION    "A.10.30"	/* 10.0 Cycle V BE/GS		*/
	#define PRODUCT_VERSION    "A.10.29"	/* 10.0 Cycle U BE/GS, IC2	*/
	#define PRODUCT_VERSION    "A.10.28"	/* 10.0 Cycle IC2 (addil bug)	*/
	#define PRODUCT_VERSION    "A.10.27"	/* 10.0 Cycle U BE/GS (addil)	*/
	#define PRODUCT_VERSION    "A.10.26"	/* 10.0 Cycle T BE/GS (addil)	*/
	#define PRODUCT_VERSION    "A.10.25"	/* 10.0 Cycle S BE/GS		*/
	#define PRODUCT_VERSION    "A.10.24"	/* 10.0 Cycle R GS		*/
	#define PRODUCT_VERSION    "A.10.23"	/* 10.0 Cycle Q GS, R BE	*/
	#define PRODUCT_VERSION    "A.10.22"	/* 10.0 Cycle Q BE		*/
	#define PRODUCT_VERSION    "A.10.21"	/* 10.0 Cycle Q BE (Pre-Submit)	*/
	#define PRODUCT_VERSION    "A.10.20"	/* 10.0 Cycle O GS, P GS	*/
	#define PRODUCT_VERSION    "A.10.19"	/* 10.0 Cycle N	GS		*/
	#define PRODUCT_VERSION    "A.10.18"	/* 10.0 Cycle N	BE		*/
	#define PRODUCT_VERSION    "A.10.17"	/* 10.0 Cycle M BE		*/
	#define PRODUCT_VERSION    "A.10.16"	/* 10.0 Cycle M GS, IC1, TAC4	*/
	#define PRODUCT_VERSION    "A.10.15"	/* 10.0 Cycle L	BE/GS		*/
	#define PRODUCT_VERSION    "A.10.14"	/* 10.0 Cycle K BE/GS		*/
	#define PRODUCT_VERSION    "A.10.13"	/* 10.0 Cycle K BE-pre		*/
	#define PRODUCT_VERSION    "A.10.12"	/* 10.0 Cycle I	BE/GS		*/
	#define PRODUCT_VERSION    "A.10.11"	/* 10.0 Cycle H BE, XAlpha-3	*/
	/* previous deliveries were done in RMS */
#endif

#else /* HANDLE_EM_ARCH_ONLY */

/* Tahoe Information */

#define PROJECT_INFO       "92453-07 linker.tahoe"

#define PRODUCT_VERSION    "TAHOE.00.07" /* BL4 */

#define PRODUCT_TYPE	  ""

#if 0 /* for archival purposes only */
	#define PRODUCT_VERSION    "TAHOE.00.06" /* SDEV3A */
	#define PRODUCT_VERSION    "TAHOE.00.05" /* 08/07/96 BE2 Final */
	#define PRODUCT_VERSION    "TAHOE.00.04" /* 07/04/95 BE2 Core */
	#define PRODUCT_VERSION    "TAHOE.00.03" /* 11/13/95 delivery of BE1 */
	#define PRODUCT_VERSION    "TAHOE.00.02" /* 10/16/95 pre BE1 delivery */
	#define PRODUCT_VERSION    "TAHOE.00.01" /* 6/30/95 submittal */
#endif

#endif 
